# use CDO to:
#   1. remap EOBS orog to alps
#   2. remap EOBS Tmean
#   3. make monthly means
# ------------------------- #

library(magrittr)
library(fs)

# paths
path_in <- "/mnt/CEPH_PROJECTS/CLIRSNOW/zz_eobs/v20.0e/"
path_out <- "/mnt/CEPH_PROJECTS/CLIRSNOW/data_evaluation/nc/"


## elev ####

# remap proc
in_file <- dir_ls(path_in, regexp = "elev")
out_file <- path(path_out, "fixed/eobs/elev.nc")
cdo_call <- paste0("cdo remapbil", 
                   ",", "data/gridspec_55x133_laea",
                   " ", in_file, 
                   " ", out_file)
system(cdo_call)


## Tmean ####

# remap proc
in_file <- dir_ls(path_in, regexp = "tg")
out_file <- path(path_out, "daily/eobs/tg.nc")
cdo_call <- paste0("cdo remapbil", 
                   ",", "data/gridspec_55x133_laea",
                   " ", "-seldate,20000101,20191231",
                   " ", in_file, 
                   " ", out_file)
system(cdo_call)

# make monthly means 

in_file <- path(path_out, "daily/eobs/tg.nc")
out_file <- path(path_out, "monthly/eobs/tg.nc")
cdo_call <- paste0("cdo monmean", 
                   " ", in_file, 
                   " ", out_file)
system(cdo_call)



## prec ####

# remap proc
in_file <- dir_ls(path_in, regexp = "rr")
out_file <- path(path_out, "daily/eobs/rr.nc")
cdo_call <- paste0("cdo remapbil", 
                   ",", "data/gridspec_55x133_laea",
                   " ", "-seldate,20000101,20191231",
                   " ", in_file, 
                   " ", out_file)
system(cdo_call)

# make monthly sums

in_file <- path(path_out, "daily/eobs/rr.nc")
out_file <- path(path_out, "monthly/eobs/rr.nc")
cdo_call <- paste0("cdo monsum", 
                   " ", in_file, 
                   " ", out_file)
system(cdo_call)


## EOF ####



