# rgi glacier inventory 60


## gridded version ####
library(raster)

rr_modis <- raster("/mnt/CEPH_PROJECTS/CLIRSNOW/data_evaluation/nc/daily/modis/modis_snc_55x133_2002-07-04.tif")
rr_rgi <- raster("data-aux/00_rgi60_30-30grid.tif")

rr_rgi_laea <- projectRaster(rr_rgi, rr_modis, method = "ngb")
rr_rgi_laea %>% plot

# what is the unit?!


## shape version ####

library(sf)
sf_rgi <- read_sf("data-aux/rgi60/")
plot(sf_rgi["Area"])

# make grid version in modis coarse grid
sf_rgi_laea <- st_transform(sf_rgi, crs(rr_modis))
plot(sf_rgi_laea["Area"])

rr_rgi <- rasterize(sf_rgi_laea, rr_modis, getCover = T)

# make data.table
source("R/functions/raster2datatable.R")
dt_rgi <- raster2datatable(rr_rgi, icell = T)
setnames(dt_rgi, "layer", "glacier_fraction")

saveRDS(dt_rgi, "data/auxilary-02-glacier-fraction.rds")





