# extract the monthly RCM grid to rds ####

library(eurocordexr)
library(foreach)


dat_inv <- get_inventory("/mnt/CEPH_PROJECTS/CLIRSNOW/data_evaluation/nc/fixed/rcm/", add_files = T)

dat_orog <- foreach(
  i_row = 1:nrow(dat_inv),
  .final = rbindlist
) %do% {
  
  foreach(
    i_file = dat_inv[i_row, list_files][[1]],
    .final = rbindlist
  ) %do% {
    
    dat_nc <- nc_grid_to_dt(i_file, "orog")
    dat_nc[, gcm := dat_inv[i_row, gcm]]
    dat_nc[, rcm := dat_inv[i_row, institute_rcm]]
    dat_nc[, experiment := dat_inv[i_row, experiment]]
    
    dat_nc
    
  }
  
}

saveRDS(dat_orog, file = "/mnt/CEPH_PROJECTS/CLIRSNOW/data_evaluation/rds/grid/00-orog.rds")
