# generate gridspec for CDO remapping
# ------------------------- #

# requirement: modis data in .nc (only temporary)
# use gdal_translate
gdal_call <- paste('gdal_translate -of netCDF -co "FORMAT=NC4"',
                   "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/nc_daily/modis_10d/modis_snc_55x133_2000-02-24.tif",
                   # "temp_laea.tif",
                   "temp_modis_snc.nc")
system(gdal_call)

# get grid description of target grid for CDO
# and save into file
cdo_call <- paste("cdo griddes",
                  "temp_modis_snc.nc",
                  ">", "data/gridspec_55x133_laea")
system(cdo_call)

# remove temporary .nc file
file.remove("temp_modis_snc.nc")

# test remap
cdo_call <- paste0("cdo remapnn",
                   ",data/gridspec_55x133_laea",
                   " /mnt/CEPH_BASEDATA/METEO/SCENARIO/SNC/snc_EUR-11_CNRM-CERFACS-CNRM-CM5_historical_r1i1p1_CLMcom-CCLM4-8-17_v1_day_19500101-19501231.nc",
                   " test-rcm.nc")
system(cdo_call)
  