# sample some pixels for bc test yday to keep it computationally in time

library(data.table)
library(raster)

zz_dat <- readRDS("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/rds/bc_comparison/03_qdm/KNMI-RACMO22E_CNRM-CERFACS-CNRM-CM5_rcp85_r1i1p1_v2_past.rds")

rr0 <- raster("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/nc_daily/modis_10d/modis_snc_55x133_2000-02-24.tif")

# stratified sample by alt
dat_aux <- readRDS("data/auxilary-03-modis.rds")
dat_aux[, alt_f := cut(alt, c(-100, 1:5*500, 3200), dig.lab = 5)]

rcm_icell <- sort(unique(zz_dat$icell))



set.seed(1234)
dat_sample <- dat_aux[icell %in% rcm_icell, sample(icell, 5), alt_f]

icell_sample <- dat_sample$V1

rr0[icell_sample] <- 100
plot(rr0)

saveRDS(icell_sample, "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/rds/sample-pixels-01-stratified-elev.rds")

