# sample some pixels for bc test yday to keep it computationally in time

library(data.table)
library(raster)
library(magrittr)





rr0 <- raster("/mnt/CEPH_PROJECTS/SNOW_3rd_gen/CLOUDREMOVAL/v1.1/clim_SCD/2000-10-01_2019-09-30.tif")
rr_elev <- raster("/mnt/CEPH_PROJECTS/SNOW_3rd_gen/CLOUDREMOVAL/v1.1/00_aux/eurac_modis_altitude_laea.tif")
rr_elev[rr_elev < -30000] <- NA

dat <- data.table(icell = 1:ncell(rr0),
                  scd = rr0[],
                  alt = rr_elev[])

dat$alt %>% summary

# stratified sample by alt
dat[, alt_f := cut(alt, c(-150, 1:9*500, 4800), dig.lab = 5)]


set.seed(1234)
dat_sample <- dat[!is.na(scd), sample(icell, 5), alt_f]
icell_sample <- dat_sample$V1

# rr0[icell_sample] <- 1000
# rr0[rr0 < 400] <- 0
# plot(rr0)

saveRDS(icell_sample, "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/rds/sample-pixels-02-high-res.rds")

