# calc clim from ds

# 2041-2070

library(raster)
library(data.table)
library(magrittr)
library(fs)
library(foreach)

source("R/functions/calc_clim_ds.R")

path_out <- "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full_clim_2041_2070/"
path_temp <- "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/temp_clim/"


dirs_ds_variant <- c(
  "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full_2041_2070/02_qm/",
  "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full_2041_2070/03_qdm/"
)


lapply(dirs_ds_variant, function(x){
  
  data.table(bc_var = path_file(x),
             path_rcm = dir_ls(x))
  
}) %>% rbindlist() -> dat_loop


mitmatmisc::init_parallel_ubuntu(6)

foreach(
  i = 1:nrow(dat_loop),
  .inorder = F
) %dopar% {
  
  i_bc_var <- dat_loop[i, bc_var]
  i_path_rcm <- dat_loop[i, path_rcm]
  i_tmpdir <- path(path_temp, i_bc_var, path_file(i_path_rcm))
  
  i_fn_out <- i_path_rcm %>% 
    path_file %>% 
    path_ext_set("tif") %>% 
    path(path_out, i_bc_var, .)
  
  dir_create(path_dir(i_fn_out))
  
  calc_clim_ds(i_path_rcm,
               i_fn_out,
               i_tmpdir)
  
  return(i_path_rcm)
}


dir_delete(path_temp)
