# calc seasonal clim from ds (only QDM)

library(raster)
library(data.table)
library(magrittr)
library(fs)
library(foreach)

source("R/functions/calc_clim_ds_seasonal.R")

path_out <- "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full_clim_seasonal/"
path_temp <- "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/temp_clim/"

# dirs_ds_variant <- c(
#   "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full/02_qm/",
#   "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full/03_qdm/",
#   "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full/04_mbc_qdm/"
# )

# dirs_ds_variant <- c(
#   "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full/02_qm/",
#   "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full/03_qdm/"
# )

# 
# lapply(dirs_ds_variant, function(x){
#   
#   data.table(bc_var = path_file(x),
#              path_rcm = dir_ls(x))
#   
# }) %>% rbindlist() -> dat_loop



dat_loop <- data.table(path_rcm = dir_ls("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full/03_qdm/"))



mitmatmisc::init_parallel_ubuntu(6)

foreach(
  i = 1:nrow(dat_loop),
  # i = 1:4, # for test
  .inorder = F
) %dopar% {
  
  i_path_rcm <- dat_loop[i, path_rcm]
  
  for(i_season in c("DJF", "MAM", "JJA", "SON")){
    
    i_tmpdir <- path(path_temp, i_season, path_file(i_path_rcm))
    
    i_fn_out <- i_path_rcm %>% 
      path_file %>% 
      path_ext_set("tif") %>% 
      path(path_out, i_season, .)
    
    dir_create(path_dir(i_fn_out))
    
    calc_clim_ds_seasonal(i_path_rcm,
                          i_fn_out,
                          i_tmpdir,
                          i_season)
    
    
    
  }
  
  return(i_path_rcm)
  
}


dir_delete(path_temp)
