# calc rgi fraction covered grid cells

library(raster)
library(sf)
library(magrittr)


sf_rgi <- read_sf("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/rgi/shp/11_rgi60_CentralEurope.shp")


# lr
rr_lr <- raster("data/sample_modis_snc_55x133_2000-03-18.tif")
sf_rgi_lr <- st_transform(sf_rgi, st_crs(rr_lr)) %>% dplyr::select(Area)

rr_rgi_lr <- rasterize(as(sf_rgi_lr, "Spatial"), rr_lr, getCover = T)
writeRaster(rr_rgi_lr, "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/rgi/modis-lr.tif")

# hr
rr_hr <- raster("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full_clim/02_qm/CLMcom-CCLM4-8-17_CNRM-CERFACS-CNRM-CM5_rcp85_r1i1p1_v1_future.tif")
sf_rgi_hr <- st_transform(sf_rgi, st_crs(rr_hr)) %>% dplyr::select(Area)

rr_rgi_hr <- rasterize(as(sf_rgi_hr, "Spatial"), rr_hr, getCover = T)
writeRaster(rr_rgi_hr, "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/rgi/modis-hr.tif")
