# create mask for flo

library(raster)
library(magrittr)
library(fs)
library(foreach)

rr_flo <- raster("data-aux/amundsen-flo-hr/maps/scf_CNRM-CERFACS-CNRM-CM5_CLMcom-CCLM4-8-17_rcp85_2000-2020.tif")
rr_modis_flo <- raster("data/rofental_modis_laea_flo.tif")



dat_loop <- data.table(fn = dir_ls("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full_clim/03_qdm/"))

dat_loop[, c("institute_rcm", "gcm", "experiment", "ensemble", "dsr", "fp") := 
           tstrsplit(path_ext_remove(path_file(fn)), "_")]

dat_loop2 <- dat_loop[, .SD[1], institute_rcm]

lapply(dat_loop2$fn, function(x){
  rr <- raster(x)
  crop(rr, rr_modis_flo)
}) %>% stack -> rr_rcm

names(rr_rcm) <- dat_loop2$institute_rcm

plot(rr_rcm)

plot(st_as_stars(rr_rcm))

# maybe not needed; focus on clm, and wrf381