# make ensemble mean of annual SCD
# - only for five RCMs in paper
# - common icell
# - by rcp

# library(raster)
library(stars)
# library(ggplot2)
# library(scico)
library(data.table)
library(magrittr)
library(fs)








# common icell ------------------------------------------------------------

dat_icell <- readRDS("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/rds/ds/common-icell.rds")
names(dat_icell)
rcms_common <- c("MODIS", "CLMcom-CCLM4-8-17", "CLMcom-ETH-COSMO-crCLIM-v1-1",
                 "CNRM-ALADIN63", "IPSL-WRF381P", "SMHI-RCA4")
lgl_icell_common <- dat_icell[, 
                              apply(.SD, 1, all), 
                              .SDcols = rcms_common]




# rcm ensemble mean -------------------------------------------------------

x <- "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full_clim/03_qdm/"
dat_loop <- data.table(bc_var = path_file(x),
                       file_rcm = dir_ls(x))

dat_loop[, c("institute_rcm", "gcm", "experiment", "ensemble", "dsr", "fp") := 
           tstrsplit(path_ext_remove(path_file(file_rcm)), "_")]

dat_loop2 <- dat_loop[institute_rcm %in% rcms_common & fp == "future"]


rs_rcp26 <- read_stars(dat_loop2[experiment == "rcp26", file_rcm],
                       along = "rcm")
rs_rcp26_mean <- st_apply(rs_rcp26, 1:2, mean)
write_stars(rs_rcp26_mean, 
            "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/scd_ensemble_mean/rcp26.tif")




rs_rcp85 <- read_stars(dat_loop2[experiment == "rcp85", file_rcm],
                       along = "rcm")
rs_rcp85_mean <- st_apply(rs_rcp85, 1:2, mean)
write_stars(rs_rcp85_mean, 
            "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/scd_ensemble_mean/rcp85.tif")

