# calc scf threshold based on vector of cp's

brks <- c(0, 0.001, 1:19/20, 0.999, 1)
scf_middle <- (head(brks, -1) + tail(brks, -1))/2

# remove near 0 and 1 pixels (if incomplete cp)
cp50_scf <- function(vals, 
                     eps = 0.001){
  
  vals[vals < 0] <- NA
  if(sum(is.na(vals)) == 0){
    
    if(length(unique(vals)) >= 2){
      approx(vals, scf_middle, 
             xout = 0.5, ties = min)$y
    } else {
      NA_real_
    }
    
  } else {
    
    ind <- which(!is.na(vals) & vals > eps & vals < (1-eps))
    if(length(ind) >= 2 & length(unique(vals[ind])) >= 2) {
      approx(vals[ind], scf_middle[ind], 
             xout = 0.5, ties = min)$y
    } else {
      NA_real_
    }
    
  }
  
}