# if applied after monotonic: 
#    eps is according to threshold there, i.e. 0.02

cp_mae <- function(x, x_cp, mat_cp, eps = 0.001, n_min_cp = 5){
  
  x_cp[x_cp < eps | (1-x_cp) < eps] <- NA
  if(sum(!is.na(x_cp)) < n_min_cp) return(NULL)
  
  mat_abs_diff <- abs(sweep(mat_cp, 2, x_cp, "-"))
  icell_n <- length(x_cp) - (mat_abs_diff %>% is.na %>% rowSums)
  
  mae <- rowMeans(mat_abs_diff, na.rm = T)
  mae[icell_n < n_min_cp] <- NA
  
  icell_min <- names(which.min(mae[mae > 0]))
  if(is.null(icell_min)) return(NULL)
  
  data.table(icell_orig = as.integer(x),
             icell_min_cp_mae = as.integer(icell_min),
             min_mae = mae[icell_min])
 }
 