# get data.table of cp SCF


# NEEDS objects: rr_cp rr_alt band_lbl

cp_rr2dt <- function(icell_sample, rr_cp = rr_cp, rr_alt = rr_alt){
  
  mat_values <- rr_cp[icell_sample]
  colnames(mat_values) <- band_lbl
  
  dt_values <- mat_values %>% 
    as.data.table()
  
  dt_values[, icell := icell_sample]
  dt_values[, alt := rr_alt[icell_sample]]
  
  dt_values %>% 
    melt(id.vars = c("icell", "alt")) -> dt_values2
  
  dt_values2[value < 0, value := NA]
  dt_values2[, c("scf_lb", "scf_ub") := tstrsplit(variable, ",")]
  dt_values2[, scf_lb := readr::parse_number(scf_lb)]
  dt_values2[, scf_ub := readr::parse_number(scf_ub)]
  dt_values2[, scf_middle := (scf_lb + scf_ub) / 2]
  dt_values2
}


cp_rr2mat <- function(icell_sample){
  
  mat <- rr_cp[icell_sample]
  mat[mat < 0] <- NA
  colnames(mat) <- band_lbl
  rownames(mat) <- icell_sample
  mat
  
}
