## create a regions raster to use in python for regional snow land line filtering ####

library(rgdal)
library(raster)

# sample modis ####

rr_sample <- raster("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/modis_gapfill/00_aux/eurac_modis_altitude_sinu.tif")

## HISTALP zones ####

shp_histalp_latlon <- readOGR("data-aux/shp-histalp-zone",
                              "Shape_CRSM")

shp_histalp_laea <- spTransform(shp_histalp_latlon,
                                crs(rr_sample))

rr_histalp_zone <- rasterize(shp_histalp_laea, rr_sample)

# rr_histalp_zone_NS <- rr_histalp_zone
# rr_histalp_zone_NS[rr_histalp_zone == 4] <- 1
# rr_histalp_zone_NS[rr_histalp_zone == 3] <- 2


## write raster ####

# remove attributes
rr_histalp_zone <- setValues(raster(rr_histalp_zone), rr_histalp_zone[])
# rr_histalp_zone_NS <- setValues(raster(rr_histalp_zone_NS), rr_histalp_zone_NS[])


# 4 regions (histalp)
writeRaster(rr_histalp_zone, 
            filename = "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/modis_gapfill/00_aux/eurac_modis_regions_4_histalp_sinu.tif",
            overwrite = T)

# 2 regions (histalp N-S)
# writeRaster(rr_histalp_zone_NS, 
#             filename = "/mnt/CEPH_PROJECTS/CLIRSNOW/MODIS_SNOW_CLOUDFREE/eurac_modis_regions_2_histalp_northsouth_laea.tif",
#             overwrite = T)
# 



## EOF ####