# check difference between SCD/SCF by elev bins

# if first agg by grid cell and then by elev
# or directly by elev

# requires objects from comp-bc-ds-rel.R and scf-th-01.R


rr_lr <- raster("data/sample_modis_snc_55x133_2000-03-18.tif")

rr_lr2 <- raster(rr_lr)
rr_lr2[] <- 0
rr_lr2[icell_common] <- 1
plot(rr_lr2)

rr_hr <- raster(rr_modis)
rr_hr[lgl_icell_common] <- 1
plot(rr_hr)


rr_hr_scd <- rr_modis
# rr_hr_scd[!lgl_icell_common] <- NA
rr_hr_scd[!(lgl_icell_common & lgl_icell_noglacier)] <- NA
rr_hr_scf <- rr_hr_scd/365

rr_hr_scf_agg <- aggregate(rr_hr_scf,
                           fact = c(37, 53),
                           fun = mean,
                           na.rm = T)
plot(rr_hr_scf_agg)


dat_bc_rr_alps <- clim_qdm2[,
                            .(snc = mean(snc_qdm)),
                            .(icell, rcm, gcm, experiment, fp)]
dat_bc_rr_alps2 <- dat_bc_rr_alps[, .(snc = mean(snc)), .(icell, experiment, fp)]
dat1 <- dat_bc_rr_alps2[fp == "past" & experiment == "rcp26"]

rr_bc <- raster(rr_lr)
rr_bc[dat1$icell] <- dat1$snc
plot(rr_bc)
plot((rr_bc - rr_hr_scf_agg)/rr_hr_scf_agg)



dat_comp <- data.table(icell = 1:ncell(rr_bc),
                       snc_bc = rr_bc[],
                       snc_hr = rr_hr_scf_agg[]) %>% 
  merge(dat_aux, by ="icell")

dat_comp[, dd := snc_bc - snc_hr]
dat_comp$dd %>% qplot

dat_comp %>% 
  ggplot(aes(alt, dd/snc_hr))+
  geom_point()


dat_comp2 <- dat_comp[!is.na(snc_bc) & !is.na(snc_hr), 
                      .(snc_bc = mean(snc_bc),
                        snc_hr = mean(snc_hr),
                        dd = mean(dd),
                        nn = .N),
                      alt_f]
dat_comp2 %>% 
  ggplot(aes(dd, alt_f))+
  geom_point()


dat_modis2 %>% 
  merge(dat_comp2, by.x = "elev_f", by.y = "alt_f") -> dat_comp3
dat_comp3[, snc_modis := scd/365]
dat_comp3[, qplot(snc_bc - snc_modis)]

dat_comp3 %>% 
  ggplot(aes((snc_bc - snc_modis)/snc_modis, elev_f))+
  geom_point()

dat_comp3 %>% 
  ggplot(aes((snc_hr - snc_modis)/snc_modis, elev_f))+
  geom_point()


dat_comp3 %>% 
  ggplot(aes(nn.x, nn.y, colour = elev_f))+
  geom_point()


lr_15 <- dat_aux[alt > 1000 & alt < 1500, icell]

rr_lr15 <- rr_lr
rr_lr15[lr_15] <- 100
plot(rr_lr15)  

rr_hr2 <- rr_elev
rr_hr2[rr_hr2 < 1000 | rr_hr2 > 1500] <- NA
plot(rr_hr2)


dat_scf_15 <- dat_scf_eval[icell_lr %in% lr_15]
dat_scf_15$alt %>% qplot
dat_scf_15$alt_lr %>% qplot
dat_scf_15 %>% summary

dat_alt_diff <- dat_scf_eval[, 
                             .(mean_alt_diff = mean(alt_diff)),
                             .(icell_lr, alt_lr)]
dat_alt_diff$mean_alt_diff %>% qplot


dat_15_inlr <- dat_scf_eval[alt > 1000 & alt < 1500 & alt_lr > 1000 & alt_lr < 1500]
dat_15_outlr <- dat_scf_eval[alt > 1000 & alt < 1500 & !(alt_lr > 1000 & alt_lr < 1500)]


dat_scf_eval[alt > 1000 & alt < 1500 & !(alt_lr > 1000 & alt_lr < 1500), qplot(alt_diff)]


dat_modis[icell %in% dat_15_inlr$icell, summary(scd)]
dat_modis[icell %in% dat_15_outlr$icell, summary(scd)]

dat_modis[icell %in% dat_15_inlr$icell, qplot(scd)]
dat_modis[icell %in% dat_15_outlr$icell, qplot(scd)]


dat_comp[icell %in% dat_15_inlr$icell_lr] %>% summary
dat_comp[icell %in% dat_15_outlr$icell_lr] %>% summary

dat_scf_eval$alt %>% qplot
dat_aux$alt %>% qplot


dat_scf_eval %>% 
  ggplot(aes(alt, after_stat(ncount)))+
  geom_freqpoly()+
  geom_freqpoly(data = dat_aux)+
  theme_bw()


