# compare scf_th seasonal

# library(raster)
library(stars)
# library(sf)
library(data.table)
library(ggplot2)
library(magrittr)
library(scico)
library(cowplot)


# data --------------------------------------------------------------------


rs_annual <- read_stars("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/scf_threshold/scf_cp50_v02_monotonic.tif")
rs_mamjja <- read_stars("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/cp_seasonal/scf_cp50_v02_monotonic_MAMJJA.tif")
rs_sondjf <- read_stars("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/cp_seasonal/scf_cp50_v02_monotonic_SONDJF.tif")



# crop to rofental
rs_rofental <- read_stars("data/rofental_modis_laea_flo.tif")

rs_annual_rof <- st_crop(rs_annual, rs_rofental)
rs_mamjja_rof <- st_crop(rs_mamjja, rs_rofental)
rs_sondjf_rof <- st_crop(rs_sondjf, rs_rofental)



# plot rofental --------------------------------------------------------------------

plot(rs_mamjja_rof - rs_sondjf_rof)
plot(rs_mamjja_rof - rs_annual_rof)
plot(rs_sondjf_rof - rs_annual_rof)


ggplot()+
  geom_stars(data = rs_mamjja_rof - rs_sondjf_rof, downsample = 0)+
  scale_fill_gradient2()+
  theme_bw()


ggplot()+
  geom_stars(data = rs_mamjja_rof - rs_annual_rof, downsample = 0)+
  scale_fill_gradient2()+
  theme_bw()
ggplot()+
  geom_stars(data = rs_sondjf_rof - rs_annual_rof, downsample = 0)+
  scale_fill_gradient2()+
  theme_bw()


