# calc SCD annual (Oct-Sep) and clim



library(magrittr)
library(fs)
library(data.table)
library(raster)

# need to manually mask water and scf_th
rr_water <- raster("/mnt/CEPH_PROJECTS/SNOW_3rd_gen/CLOUDREMOVAL/v1.1/00_aux/eurac_modis_water_mask_laea.tif")
rr_scf_th <- raster("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/scf_threshold/scf_cp50_v04_imputed_alt.tif")




file_out <- "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/eval_upscaled_modis/alps-clim/2000-10-01_2019-09-30.tif"
fns <- dir_ls("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/eval_upscaled_modis/alps-monthly/")
path_temp_proc <- "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/eval_upscaled_modis/alps-hydroyear/"

dt_fns <- data.table(fn = fns)
dt_fns[, year_month := fn %>% 
         path_file %>% 
         path_ext_remove]
dt_fns[, c("year", "month") := tstrsplit(year_month, "-", type.convert = T)]
mitmatmisc::add_hydro_year(dt_fns)

dt_fns[, .N, hydro_year]
dt_fns_hydro <- dt_fns[hydro_year %in% 2001:2019]

dir_create(path_temp_proc)

for(i_year in unique(dt_fns_hydro$hydro_year)){
  
  fn_out <- path(path_temp_proc, i_year, ext = "tif")
  # if(file_exists(fn_out)) next
  fns_i <- dt_fns_hydro[hydro_year == i_year, fn]
  rrs_i <- stack(fns_i)
  rrs_i_out <- calc(rrs_i, sum, na.rm = T) # na.rm=T (new)
  # need to manually mask water and scf_th
  rrs_i_out[rr_water == 1] <- NA
  rrs_i_out[is.na(rr_scf_th)] <- NA
  
  writeRaster(rrs_i_out, fn_out, overwrite = T)
  
}

rrs <- stack(dir_ls(path_temp_proc))
rrs_clim <- calc(rrs, mean, na.rm = T) # na.rm=T (new)
rrs_clim[rrs_clim < 0] <- NA

# plot(rrs_clim)

writeRaster(rrs_clim, filename = file_out, overwrite = T)
# dir_delete(path_temp_proc)