# data for zenodo




# --------------------------- #
# -> copy manually
#    - scd ensemble mean
# --------------------------- #






library(data.table)
library(magrittr)
library(fs)

path_out <- "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/paper-fig-table/zenodo/data_downscaling/"

files_past <- dir_ls("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full_clim/03_qdm/", regexp = "past")
files_2041 <- dir_ls("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full_clim_2041_2070/03_qdm/", regexp = "future")
files_2071 <- dir_ls("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full_clim/03_qdm/", regexp = "future")

# remove wrf331
files_past <- grep("WRF331", files_past, value = T, invert = T)
files_2041 <- grep("WRF331", files_2041, value = T, invert = T)
files_2071 <- grep("WRF331", files_2071, value = T, invert = T)


for(i_fn in files_past){
  fn_in <- i_fn
  fn_out <- path(path_out, "single_rcm_2001_2020", sub("_past", "", path_file(i_fn)))
  dir_create(path_dir(fn_out))
  file_copy(fn_in, fn_out)
}


for(i_fn in files_2041){
  fn_in <- i_fn
  fn_out <- path(path_out, "single_rcm_2041_2070", sub("_future", "", path_file(i_fn)))
  dir_create(path_dir(fn_out))
  file_copy(fn_in, fn_out)
}


for(i_fn in files_2071){
  fn_in <- i_fn
  fn_out <- path(path_out, "single_rcm_2071_2100", sub("_future", "", path_file(i_fn)))
  dir_create(path_dir(fn_out))
  file_copy(fn_in, fn_out)
}
