# get MODIS data


library(raster)
# library(stars)
library(data.table)
library(lubridate)
library(magrittr)
library(fs)


rr_scd <- raster("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/modis_scd/clim/2000-08-01_2020-07-31.tif")


rr_elev <- raster("/mnt/CEPH_PROJECTS/SNOW_3rd_gen/CLOUDREMOVAL/v1.1/00_aux/eurac_modis_altitude_laea.tif")
rr_elev[rr_elev < -30000] <- NA

rr_corine <- raster("/mnt/CEPH_PROJECTS/SNOW_3rd_gen/CLOUDREMOVAL/v1.1/00_aux/aux_laea.tif", 3)
rr_elev[rr_corine == 0] <- NA


dat_scd <- data.table(icell = 1:ncell(rr_elev),
                      # water = rr_water[],
                      scd = rr_scd[],
                      elev = rr_elev[])

dat_scd[, elev_f := cut(elev, c(-150, seq(-50, 4550, by = 100), 4800), dig.lab = 5)]
dat_scd_nn <- dat_scd[!is.na(scd), .N, elev_f]
# dat_scd_nn

dat_scd[, scd_avg := mean(scd, na.rm = T), elev_f]
dat_scd[, scd_anom := scd - scd_avg]

rr_scd_new <- raster(rr_scd)
rr_scd_new[] <- dat_scd$scd_anom

plot(rr_scd_new)

writeRaster(rr_scd_new, 
            filename = "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/modis_scd/clim-elev-anom/2000-08-01_2020-07-31.tif")





