# calc clim from ds

library(raster)
library(data.table)
library(magrittr)
library(fs)
library(foreach)

source("R/functions/calc_clim_ds.R")

path_out <- "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full_clim/"
path_temp <- "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/temp_clim/"

# dirs_ds_variant <- c(
#   "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full/02_qm/",
#   "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full/03_qdm/",
#   "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full/04_mbc_qdm/"
# )

dirs_ds_variant <- c(
  # "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full/02_qm/",
  "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full/03_qdm/"
)


lapply(dirs_ds_variant, function(x){
  
  data.table(bc_var = path_file(x),
             path_rcm = dir_ls(x))
  
}) %>% rbindlist() -> dat_loop


mitmatmisc::init_parallel_ubuntu(13)

foreach(
  i = 1:nrow(dat_loop),
  .inorder = F
) %dopar% {
  
  i_bc_var <- dat_loop[i, bc_var]
  i_path_rcm <- dat_loop[i, path_rcm]
  i_tmpdir <- path(path_temp, i_bc_var, path_file(i_path_rcm))
  
  i_fn_out <- i_path_rcm %>% 
    path_file %>% 
    path_ext_set("tif") %>% 
    path(path_out, i_bc_var, .)
  
  dir_create(path_dir(i_fn_out))
  
  calc_clim_ds_hydroyear(path_in = i_path_rcm,
                         file_out = i_fn_out,
                         path_temp_proc = i_tmpdir)
  
  return(i_path_rcm)
}


dir_delete(path_temp)
