# compare flo data to ds

# library(stars)
library(raster)
library(data.table)
library(magrittr)
library(ggplot2)
library(cowplot)
library(fs)
library(foreach)




# check that rca4 has two missing large-scale pixels (which elev?  --------



rr_template_ds <- raster("data/rofental_modis_laea_flo.tif")
rr_elev <- raster("/mnt/CEPH_PROJECTS/SNOW_3rd_gen/CLOUDREMOVAL/v1.1/00_aux/eurac_modis_altitude_laea.tif")
rr_water <- raster("/mnt/CEPH_PROJECTS/SNOW_3rd_gen/CLOUDREMOVAL/v1.1/00_aux/eurac_modis_water_mask_laea.tif")
rr_elev[rr_water == 1] <- NA

rr_elev_rofental <- crop(rr_elev, rr_template_ds)

rr_rca4 <- raster("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full_clim/03_qdm/SMHI-RCA4_CNRM-CERFACS-CNRM-CM5_rcp85_r1i1p1_v1_future.tif")
rr_rca4_rofental <- crop(rr_rca4, rr_template_ds)
rr_elev_rofental_rca4 <- rr_elev_rofental
rr_elev_rofental_rca4[is.na(rr_rca4_rofental)] <- NA

dat_elev <- data.table(icell = 1:ncell(rr_elev_rofental),
                       elev = rr_elev_rofental[],
                       elev_rca4 = rr_elev_rofental_rca4[])


# qplot(dat_elev$elev)
# summary(dat_elev$elev)
dat_elev[, elev_f := cut(elev, c(seq(800, 3500, by = 100), 3800), dig.lab = 5)]
# dat_elev[, .N, keyby = elev_f]


# add glacier

rr_rgi <- raster("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/rgi/modis-hr.tif")
rr_rgi_rofental <- crop(rr_rgi, rr_template_ds)
dat_elev[, rgi := rr_rgi_rofental[]]
# mitmatmisc::init_parallel_ubuntu(5)


# check which elev with glaciers
# dat_elev %>% 
#   ggplot(aes(elev, fill = !is.na(elev_rca4) & rgi <= 0.1))+
#   geom_histogram()
# 
# dat_elev %>% 
#   with(table(elev_f, !is.na(elev_rca4) & rgi <= 0.1)) %>% 
#   prop.table(margin = 1)




# c("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full_rofental_rds/03_qdm/",
#   "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full_rofental_rds/02_qm/") %>% 
c("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full_rofental_rds/03_qdm/") %>% 
  lapply(function(x){
    
    data.table(bc_var = path_file(x),
               fn = dir_ls(x))
    
  }) %>% rbindlist -> dat_loop

dat_loop[, c("institute_rcm", "gcm", "experiment", "ensemble", "dsr", "fp") := 
           tstrsplit(path_ext_remove(path_file(fn)), "_")]


path_out <- "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/bc_full_rofental_rds_comp_amundsen/"



# ds data elev ------------------------------------------------------------


foreach(
  # i = seq_len(nrow(dat_loop)),
  i = rev(seq_len(nrow(dat_loop))), # rca4 first
  .inorder = F
) %do% {
  
  i_bc_var <- dat_loop[i, bc_var]
  i_fn <- dat_loop[i, fn]
  
  out <- NULL
  
  
  # # elev
  # 
  # i_fn_out <- i_fn %>% 
  #   path_file %>% 
  #   path(path_out, "elev", i_bc_var, .)
  # 
  # if(file_exists(i_fn_out)) {
  #   out <- c(out, paste0("Skipped: ", i_fn))
  # } else {
  #   
  #   
  #   dir_create(path_dir(i_fn_out))
  #   
  #   dat_i <- readRDS(dat_loop[i, fn])
  #   dat_i2 <- merge(dat_i, dat_elev[!is.na(elev_f), .(icell, elev_f)])
  #   
  #   dat_i2_elev <- dat_i2[, .(scf = mean(snc == 1, na.rm = T)), elev_f]
  #   
  #   dat_out <- dat_i2_elev %>% 
  #     cbind(dat_loop[i, .(bc_var, institute_rcm, gcm, experiment, fp)])
  #   
  #   saveRDS(dat_out, i_fn_out)
  #   out <- c(out, i_fn)
  # }
  
  
  
  # # month
  # 
  # i_fn_out <- i_fn %>% 
  #   path_file %>% 
  #   path(path_out, "month", i_bc_var, .)
  # 
  # if(file_exists(i_fn_out)) {
  #   out <- c(out, paste0("Skipped: ", i_fn))
  # } else {
  #   
  #   dir_create(path_dir(i_fn_out))
  #   
  #   dat_i_month <- dat_i[, .(scf = mean(snc == 1, na.rm = T)), month(date)]
  #   
  #   dat_out2 <- dat_i_month %>% 
  #     cbind(dat_loop[i, .(bc_var, institute_rcm, gcm, experiment, fp)])
  #   
  #   saveRDS(dat_out2, i_fn_out)
  #   out <- c(out, i_fn)
  # }
  # 
  # 
  # # elev no glacier
  # 
  # i_fn_out <- i_fn %>% 
  #   path_file %>% 
  #   path(path_out, "elev_noglacier", i_bc_var, .)
  # 
  # if(file_exists(i_fn_out)) {
  #   out <- c(out, paste0("Skipped: ", i_fn))
  # } else {
  #   
  #   
  #   dir_create(path_dir(i_fn_out))
  #   
  #   dat_i <- readRDS(dat_loop[i, fn])
  #   dat_i2 <- merge(dat_i, dat_elev[!is.na(elev_f) & rgi <= 0.1, .(icell, elev_f)])
  #   
  #   dat_i2_elev <- dat_i2[, .(scf = mean(snc == 1, na.rm = T)), elev_f]
  #   
  #   dat_out <- dat_i2_elev %>% 
  #     cbind(dat_loop[i, .(bc_var, institute_rcm, gcm, experiment, fp)])
  #   
  #   saveRDS(dat_out, i_fn_out)
  #   out <- c(out, i_fn)
  # }
  
  
  # elev no glacier no rca4
  
  i_fn_out <- i_fn %>% 
    path_file %>% 
    path(path_out, "elev_noglacier_norca4_season", i_bc_var, .)
  
  if(file_exists(i_fn_out)) {
    out <- c(out, paste0("Skipped: ", i_fn))
  } else {
    
    
    dir_create(path_dir(i_fn_out))
    
    dat_i <- readRDS(dat_loop[i, fn])
    
    # split by icell because of computation issues
    all_icell <- sort(unique(dat_i$icell))
    
    dat_i2 <- foreach(
      i_icell = all_icell,
      .final = rbindlist
    ) %do% {
      
      
      dat_i_icell <- dat_i[icell == i_icell]
      
      dat_i_icell[, month := month(date)]
      dat_i_icell[, year := year(date)]
      mitmatmisc::add_hydro_year(dat_i_icell, 8)
      dat_i_icell[, season := mitmatmisc::season_fct(month)]
      dat_i_icell[season == "JJA", hydro_year := year] # since JJA over hydro_year month change, needs actual year for seasonal value
      
      dat_i_icell2 <- dat_i_icell[, 
                      .(scf = mean(snc == 1, na.rm = T),
                        nn = .N), 
                      .(icell, season, hydro_year)]
      
      # full season only
      dat_i_icell2[nn >= 90,
                   .(scf = mean(scf)),
                   .(icell, season)]
    }
    
    rm(dat_i); gc()
    
    
    
    dat_i3 <- merge(dat_i2, dat_elev[!is.na(elev_f) & rgi <= 0.1 & !is.na(elev_rca4), .(icell, elev_f)])
    
    
    dat_i3_elev <- dat_i3[,
                          .(scf = mean(scf)),
                          .(elev_f, season)]
    

    dat_out <- dat_i3_elev %>% 
      cbind(dat_loop[i, .(bc_var, institute_rcm, gcm, experiment, fp)])
    
    saveRDS(dat_out, i_fn_out)
    out <- c(out, i_fn)
  }
  
  
  return(out)
}

