# calc SCD annual (Oct-Sep) and clim



library(magrittr)
library(fs)
library(data.table)
library(raster)

source("R/functions/calc_clim_ds_seasonal.R")

# need to manually mask water and scf_th
rr_water <- raster("/mnt/CEPH_PROJECTS/SNOW_3rd_gen/CLOUDREMOVAL/v1.1/00_aux/eurac_modis_water_mask_laea.tif")
rr_scf_th <- raster("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/scf_threshold/scf_cp50_v04_imputed_alt.tif")



path_in <- "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/eval_upscaled_modis/alps-monthly/"
path_out <- "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/eval_upscaled_modis/alps-clim-season/"
path_temp <- "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/temp_clim/"


for(i_season in c("DJF", "MAM", "JJA", "SON")){
  
  i_tmpdir <- path(path_temp, i_season)
  
  i_fn_out <- path(path_out, i_season, ext = "tif")
  
  dir_create(path_dir(i_fn_out))
  
  calc_clim_ds_seasonal_hydro_year(path_in = path_in,
                                   file_out = i_fn_out,
                                   path_temp_proc = i_tmpdir,
                                   season = i_season,
                                   na.rm = T)
  
  rr_i <- raster(i_fn_out)
  
  # need to manually mask water and scf_th
  rr_i[rr_water == 1] <- NA
  rr_i[is.na(rr_scf_th)] <- NA
  
  writeRaster(rr_i, i_fn_out, overwrite = T)
  
}




