# make monotonic and calc scf threshold for seasonal CP

library(raster)
# library(stars)
# library(sf)
library(data.table)
library(ggplot2)
library(magrittr)

# rr_alt <- raster("/mnt/CEPH_PROJECTS/SNOW_3rd_gen/CLOUDREMOVAL/v1.1/00_aux/eurac_modis_altitude_laea.tif")
# rr_alt[rr_alt < -30000] <- NA

# 20bin

cut(0:100/100, breaks = c(0, 0.001, 1:19/20, 0.999, 1), include.lowest = T) %>% 
  levels -> band_lbl
brks <- c(0, 0.001, 1:19/20, 0.999, 1)
scf_middle <- (head(brks, -1) + tail(brks, -1))/2

source("R/functions/longest_subseq.R")

Sys.time()
rr_cp <- brick("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/cp_seasonal/cp_20bins_MAMJJA.tif")
rr_scf1 <- calc(rr_cp, monotonic_cp_buffer, 
                filename = "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/cp_seasonal/cp_20bins_MAMJJA_monotonic.tif",
                overwrite = T)
Sys.time()
rr_cp <- brick("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/cp_seasonal/cp_20bins_SONDJF.tif")
rr_scf1 <- calc(rr_cp, monotonic_cp_buffer, 
                filename = "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/cp_seasonal/cp_20bins_SONDJF_monotonic.tif",
                overwrite = T)
Sys.time()

source("R/functions/cp50_scf.R")


Sys.time()
rr_cp <- brick("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/cp_seasonal/cp_20bins_MAMJJA_monotonic.tif")
rr_scf1 <- calc(rr_cp, cp50_scf, 
                filename = "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/cp_seasonal/scf_cp50_v02_monotonic_MAMJJA.tif",
                overwrite = T)
Sys.time()
rr_cp <- brick("/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/cp_seasonal/cp_20bins_SONDJF_monotonic.tif")
rr_scf1 <- calc(rr_cp, cp50_scf, 
                filename = "/mnt/CEPH_PROJECTS/CLIRSNOW/data_bc/ds/cp_seasonal/scf_cp50_v02_monotonic_SONDJF.tif",
                overwrite = T)
Sys.time()




