library(raster)
library(data.table)
library(magrittr)
library(ggplot2)
library(fs)



# maps --------------------------------------------------------------------



rr1 <- raster("data-aux/amundsen-flo-hr/maps/scf_CNRM-CERFACS-CNRM-CM5_CLMcom-CCLM4-8-17_rcp26_2000-2020.tif")
rr2 <- raster("data-aux/amundsen-flo-hr/maps/scf_CNRM-CERFACS-CNRM-CM5_CLMcom-CCLM4-8-17_rcp26_2071-2100.tif")
plot(rr2)

rr3 <- raster("data-aux/amundsen-flo-hr/maps/scf_MPI-M-MPI-ESM-LR_SMHI-RCA4_rcp85_2071-2100.tif")
rr3
plot(rr3)

files_maps <- dir_ls("data-aux/amundsen-flo-hr/maps/")
rrs <- stack(files_maps)
rrs
plot(rrs[[1:16]])
files_maps[1:16] %>% path_file


plot(rrs[[17:32]])
files_maps[17:32] %>% path_file


plot(rrs[[33:48]])
files_maps[33:48] %>% path_file

plot(rrs[[49:56]])
files_maps[49:56] %>% path_file

rrs_mean <- cellStats(rrs, mean)
files_maps[is.na(rrs_mean)] %>% path_file

files_maps[!is.na(rrs_mean)] %>% path_file

# missing maps -> NA rcp26 simulations (no full table rcm*gcm*exp)

# remove missing files

file_delete(files_maps[is.na(rrs_mean)])


# data --------------------------------------------------------------------

dat1 <- fread("data-aux/amundsen-flo-hr/scf_by_elev_rcp26_2000-2020.csv")
dat1 <- fread("data-aux/amundsen-flo-hr/scf_by_elev_rcp26_2071-2100.csv")
dat1 <- fread("data-aux/amundsen-flo-hr/scf_by_elev_rcp85_2071-2100.csv")
dat1 %>% 
  melt(id.vars = "elev") %>% 
  ggplot(aes(value, elev, colour = variable))+
  geom_point()+
  geom_line()


dat2 <- fread("data-aux/amundsen-flo-hr/scf_by_month_rcp26_2000-2020.csv")
dat2 <- fread("data-aux/amundsen-flo-hr/scf_by_month_rcp85_2071-2100.csv")
dat2 %>% 
  melt(id.vars = "month") %>% 
  ggplot(aes(month, value, colour = variable))+
  geom_point()+
  geom_line()
